
package net.mcreator.minecraft_delta_mod.entity;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.EntityEntryBuilder;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.client.registry.RenderingRegistry;

import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.world.BossInfoServer;
import net.minecraft.world.BossInfo;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.item.Item;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.monster.EntityMob;
import net.minecraft.entity.effect.EntityLightningBolt;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAILeapAtTarget;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAIAttackMelee;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.EnumCreatureAttribute;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.entity.RenderLiving;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.model.ModelBox;
import net.minecraft.client.model.ModelBase;

import net.mcreator.minecraft_delta_mod.procedure.ProcedureAsbundTheBarrenKingThisEntityKillsAnotherOne;
import net.mcreator.minecraft_delta_mod.procedure.ProcedureAsbundTheBarrenKingPlayerCollidesWithThisEntity;
import net.mcreator.minecraft_delta_mod.procedure.ProcedureAsbundTheBarrenKingOnEntityTickUpdate;
import net.mcreator.minecraft_delta_mod.procedure.ProcedureAsbundTheBarrenKingItIsStruckByLightning;
import net.mcreator.minecraft_delta_mod.procedure.ProcedureAsbundTheBarrenKingEntityIsHurt;
import net.mcreator.minecraft_delta_mod.procedure.ProcedureAsbundTheBarrenKingEntityFalls;
import net.mcreator.minecraft_delta_mod.procedure.ProcedureAsbundTheBarrenKingEntityDies;
import net.mcreator.minecraft_delta_mod.ElementsMinecraftDeltaMod;

import java.util.Iterator;
import java.util.ArrayList;

@ElementsMinecraftDeltaMod.ModElement.Tag
public class EntityAsbundTheBarrenKing extends ElementsMinecraftDeltaMod.ModElement {
	public static final int ENTITYID = 15;
	public static final int ENTITYID_RANGED = 16;
	public EntityAsbundTheBarrenKing(ElementsMinecraftDeltaMod instance) {
		super(instance, 204);
	}

	@Override
	public void initElements() {
		elements.entities.add(() -> EntityEntryBuilder.create().entity(EntityCustom.class)
				.id(new ResourceLocation("minecraft_delta_mod", "asbundthebarrenking"), ENTITYID).name("asbundthebarrenking").tracker(200, 3, true)
				.build());
	}

	private Biome[] allbiomes(net.minecraft.util.registry.RegistryNamespaced<ResourceLocation, Biome> in) {
		Iterator<Biome> itr = in.iterator();
		ArrayList<Biome> ls = new ArrayList<Biome>();
		while (itr.hasNext())
			ls.add(itr.next());
		return ls.toArray(new Biome[ls.size()]);
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void preInit(FMLPreInitializationEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(EntityCustom.class, renderManager -> {
			return new RenderLiving(renderManager, new ModelKingBarrenToad(), 1.3f) {
				protected ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("minecraft_delta_mod:textures/kingbarrentoad_cmos_1.png");
				}
			};
		});
	}
	public static class EntityCustom extends EntityMob {
		public EntityCustom(World world) {
			super(world);
			setSize(2.7f, 3.9f);
			experienceValue = 20;
			this.isImmuneToFire = true;
			setNoAI(!true);
		}

		@Override
		protected void initEntityAI() {
			super.initEntityAI();
			this.targetTasks.addTask(1, new EntityAIHurtByTarget(this, false));
			this.targetTasks.addTask(2, new EntityAINearestAttackableTarget(this, EntityPlayer.class, true, true));
			this.tasks.addTask(3, new EntityAIAttackMelee(this, 0.8, false));
			this.tasks.addTask(4, new EntityAILookIdle(this));
			this.tasks.addTask(5, new EntityAISwimming(this));
			this.tasks.addTask(6, new EntityAILeapAtTarget(this, (float) 0.8));
		}

		@Override
		public EnumCreatureAttribute getCreatureAttribute() {
			return EnumCreatureAttribute.UNDEFINED;
		}

		@Override
		protected Item getDropItem() {
			return null;
		}

		@Override
		public net.minecraft.util.SoundEvent getAmbientSound() {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(""));
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(""));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(""));
		}

		@Override
		protected float getSoundVolume() {
			return 1.0F;
		}

		@Override
		public void onStruckByLightning(EntityLightningBolt entityLightningBolt) {
			super.onStruckByLightning(entityLightningBolt);
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			Entity entity = this;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("entity", entity);
				ProcedureAsbundTheBarrenKingItIsStruckByLightning.executeProcedure($_dependencies);
			}
		}

		@Override
		public void fall(float l, float d) {
			super.fall(l, d);
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			Entity entity = this;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("x", x);
				$_dependencies.put("y", y);
				$_dependencies.put("z", z);
				$_dependencies.put("world", world);
				ProcedureAsbundTheBarrenKingEntityFalls.executeProcedure($_dependencies);
			}
		}

		@Override
		public boolean attackEntityFrom(DamageSource source, float amount) {
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			Entity entity = this;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("x", x);
				$_dependencies.put("y", y);
				$_dependencies.put("z", z);
				$_dependencies.put("world", world);
				ProcedureAsbundTheBarrenKingEntityIsHurt.executeProcedure($_dependencies);
			}
			if (source == DamageSource.FALL)
				return false;
			return super.attackEntityFrom(source, amount);
		}

		@Override
		public void onDeath(DamageSource source) {
			super.onDeath(source);
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			Entity entity = this;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("x", x);
				$_dependencies.put("y", y);
				$_dependencies.put("z", z);
				$_dependencies.put("world", world);
				ProcedureAsbundTheBarrenKingEntityDies.executeProcedure($_dependencies);
			}
		}

		@Override
		public void onKillEntity(EntityLivingBase entity) {
			super.onKillEntity(entity);
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("entity", entity);
				ProcedureAsbundTheBarrenKingThisEntityKillsAnotherOne.executeProcedure($_dependencies);
			}
		}

		@Override
		public void onEntityUpdate() {
			super.onEntityUpdate();
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			Entity entity = this;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("entity", entity);
				$_dependencies.put("x", x);
				$_dependencies.put("y", y);
				$_dependencies.put("z", z);
				$_dependencies.put("world", world);
				ProcedureAsbundTheBarrenKingOnEntityTickUpdate.executeProcedure($_dependencies);
			}
		}

		@Override
		public void onCollideWithPlayer(EntityPlayer entity) {
			super.onCollideWithPlayer(entity);
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("entity", entity);
				ProcedureAsbundTheBarrenKingPlayerCollidesWithThisEntity.executeProcedure($_dependencies);
			}
		}

		@Override
		protected void applyEntityAttributes() {
			super.applyEntityAttributes();
			if (this.getEntityAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getEntityAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(0.5D);
			if (this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.2D);
			if (this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(150D);
			if (this.getEntityAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) != null)
				this.getEntityAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(3D);
		}

		@Override
		public boolean isNonBoss() {
			return false;
		}
		private final BossInfoServer bossInfo = new BossInfoServer(this.getDisplayName(), BossInfo.Color.BLUE, BossInfo.Overlay.NOTCHED_6);
		@Override
		public void addTrackingPlayer(EntityPlayerMP player) {
			super.addTrackingPlayer(player);
			this.bossInfo.addPlayer(player);
		}

		@Override
		public void removeTrackingPlayer(EntityPlayerMP player) {
			super.removeTrackingPlayer(player);
			this.bossInfo.removePlayer(player);
		}

		@Override
		public void onUpdate() {
			super.onUpdate();
			this.bossInfo.setPercent(this.getHealth() / this.getMaxHealth());
		}

		@Override
		public void setNoGravity(boolean ignored) {
			super.setNoGravity(true);
		}
	}

	// Made with Blockbench
	// Paste this code into your mod.
	public static class ModelKingBarrenToad extends ModelBase {
		private final ModelRenderer body;
		private final ModelRenderer leftleg;
		private final ModelRenderer rightleg;
		private final ModelRenderer leftbackleg;
		private final ModelRenderer rightbackleg;
		private final ModelRenderer leftlegbackbottom;
		private final ModelRenderer rightlegbackbottom;
		public ModelKingBarrenToad() {
			textureWidth = 256;
			textureHeight = 256;
			body = new ModelRenderer(this);
			body.setRotationPoint(0.0F, 24.0F, 0.0F);
			setRotationAngle(body, -0.3491F, 0.0F, 0.0F);
			body.cubeList.add(new ModelBox(body, 0, 0, -18.3082F, -36.2054F, -61.0272F, 36, 24, 73, 0.0F, false));
			leftleg = new ModelRenderer(this);
			leftleg.setRotationPoint(0.0F, 24.0F, 0.0F);
			leftleg.cubeList.add(new ModelBox(leftleg, 120, 120, -21.3595F, -36.0F, -48.8218F, 12, 36, 12, 0.0F, false));
			rightleg = new ModelRenderer(this);
			rightleg.setRotationPoint(0.0F, 24.0F, 0.0F);
			rightleg.cubeList.add(new ModelBox(rightleg, 72, 97, 9.1541F, -36.0F, -48.8218F, 12, 36, 12, 0.0F, false));
			leftbackleg = new ModelRenderer(this);
			leftbackleg.setRotationPoint(0.0F, 24.0F, 0.0F);
			leftbackleg.cubeList.add(new ModelBox(leftbackleg, 0, 97, -24.4109F, -24.0F, -6.1027F, 12, 24, 24, 0.0F, false));
			rightbackleg = new ModelRenderer(this);
			rightbackleg.setRotationPoint(0.0F, 24.0F, 0.0F);
			rightbackleg.cubeList.add(new ModelBox(rightbackleg, 0, 0, 12.2054F, -24.0F, -6.1027F, 12, 24, 24, 0.0F, false));
			leftlegbackbottom = new ModelRenderer(this);
			leftlegbackbottom.setRotationPoint(0.0F, 24.0F, 0.0F);
			leftlegbackbottom.cubeList.add(new ModelBox(leftlegbackbottom, 0, 145, -24.4109F, -12.0F, -18.3082F, 12, 12, 12, 0.0F, false));
			rightlegbackbottom = new ModelRenderer(this);
			rightlegbackbottom.setRotationPoint(0.0F, 24.0F, 0.0F);
			rightlegbackbottom.cubeList.add(new ModelBox(rightlegbackbottom, 0, 48, 12.2054F, -12.0F, -18.3082F, 12, 12, 12, 0.0F, false));
		}

		@Override
		public void render(Entity entity, float f, float f1, float f2, float f3, float f4, float f5) {
			body.render(f5);
			leftleg.render(f5);
			rightleg.render(f5);
			leftbackleg.render(f5);
			rightbackleg.render(f5);
			leftlegbackbottom.render(f5);
			rightlegbackbottom.render(f5);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}
	}
}
